diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/bindings/modulegen__gcc_LP64.py ns-3.36/src/stats/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/stats/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:58.150735000 -0700
@@ -3309,119 +3282,6 @@
                    is_const=True, is_virtual=True)
     return
 
-def register_Ns3SQLiteOutput_methods(root_module, cls):
-    ## sqlite-output.h (module 'stats'): ns3::SQLiteOutput::SQLiteOutput(ns3::SQLiteOutput const & arg0) [constructor]
-    cls.add_constructor([param('ns3::SQLiteOutput const &', 'arg0')])
-    ## sqlite-output.h (module 'stats'): ns3::SQLiteOutput::SQLiteOutput(std::string const & name, std::string const & semName) [constructor]
-    cls.add_constructor([param('std::string const &', 'name'), param('std::string const &', 'semName')])
-    ## sqlite-output.h (module 'stats'): void ns3::SQLiteOutput::SetJournalInMemory() [member function]
-    cls.add_method('SetJournalInMemory', 
-                   'void', 
-                   [])
-    ## sqlite-output.h (module 'stats'): bool ns3::SQLiteOutput::SpinExec(std::string const & cmd) const [member function]
-    cls.add_method('SpinExec', 
-                   'bool', 
-                   [param('std::string const &', 'cmd')], 
-                   is_const=True)
-    ## sqlite-output.h (module 'stats'): bool ns3::SQLiteOutput::SpinExec(sqlite3_stmt * stmt) const [member function]
-    cls.add_method('SpinExec', 
-                   'bool', 
-                   [param('sqlite3_stmt *', 'stmt')], 
-                   is_const=True)
-    ## sqlite-output.h (module 'stats'): static int ns3::SQLiteOutput::SpinFinalize(sqlite3_stmt * stmt) [member function]
-    cls.add_method('SpinFinalize', 
-                   'int', 
-                   [param('sqlite3_stmt *', 'stmt')], 
-                   is_static=True)
-    ## sqlite-output.h (module 'stats'): bool ns3::SQLiteOutput::SpinPrepare(sqlite3_stmt * * stmt, std::string const & cmd) const [member function]
-    cls.add_method('SpinPrepare', 
-                   'bool', 
-                   [param('sqlite3_stmt * *', 'stmt'), param('std::string const &', 'cmd')], 
-                   is_const=True)
-    ## sqlite-output.h (module 'stats'): static int ns3::SQLiteOutput::SpinReset(sqlite3_stmt * stmt) [member function]
-    cls.add_method('SpinReset', 
-                   'int', 
-                   [param('sqlite3_stmt *', 'stmt')], 
-                   is_static=True)
-    ## sqlite-output.h (module 'stats'): static int ns3::SQLiteOutput::SpinStep(sqlite3_stmt * stmt) [member function]
-    cls.add_method('SpinStep', 
-                   'int', 
-                   [param('sqlite3_stmt *', 'stmt')], 
-                   is_static=True)
-    ## sqlite-output.h (module 'stats'): bool ns3::SQLiteOutput::WaitExec(std::string const & cmd) const [member function]
-    cls.add_method('WaitExec', 
-                   'bool', 
-                   [param('std::string const &', 'cmd')], 
-                   is_const=True)
-    ## sqlite-output.h (module 'stats'): bool ns3::SQLiteOutput::WaitExec(sqlite3_stmt * stmt) const [member function]
-    cls.add_method('WaitExec', 
-                   'bool', 
-                   [param('sqlite3_stmt *', 'stmt')], 
-                   is_const=True)
-    ## sqlite-output.h (module 'stats'): bool ns3::SQLiteOutput::WaitPrepare(sqlite3_stmt * * stmt, std::string const & cmd) const [member function]
-    cls.add_method('WaitPrepare', 
-                   'bool', 
-                   [param('sqlite3_stmt * *', 'stmt'), param('std::string const &', 'cmd')], 
-                   is_const=True)
-    ## sqlite-output.h (module 'stats'): static bool ns3::SQLiteOutput::CheckError(sqlite3 * db, int rc, std::string const & cmd, sem_t * sem, bool hardExit) [member function]
-    cls.add_method('CheckError', 
-                   'bool', 
-                   [param('sqlite3 *', 'db'), param('int', 'rc'), param('std::string const &', 'cmd'), param('sem_t *', 'sem'), param('bool', 'hardExit')], 
-                   is_static=True, visibility='protected')
-    ## sqlite-output.h (module 'stats'): static void ns3::SQLiteOutput::Error(sqlite3 * db, std::string const & cmd) [member function]
-    cls.add_method('Error', 
-                   'void', 
-                   [param('sqlite3 *', 'db'), param('std::string const &', 'cmd')], 
-                   is_static=True, visibility='protected')
-    ## sqlite-output.h (module 'stats'): static int ns3::SQLiteOutput::SpinExec(sqlite3 * db, std::string const & cmd) [member function]
-    cls.add_method('SpinExec', 
-                   'int', 
-                   [param('sqlite3 *', 'db'), param('std::string const &', 'cmd')], 
-                   is_static=True, visibility='protected')
-    ## sqlite-output.h (module 'stats'): static int ns3::SQLiteOutput::SpinExec(sqlite3 * db, sqlite3_stmt * stmt) [member function]
-    cls.add_method('SpinExec', 
-                   'int', 
-                   [param('sqlite3 *', 'db'), param('sqlite3_stmt *', 'stmt')], 
-                   is_static=True, visibility='protected')
-    ## sqlite-output.h (module 'stats'): static int ns3::SQLiteOutput::SpinPrepare(sqlite3 * db, sqlite3_stmt * * stmt, std::string const & cmd) [member function]
-    cls.add_method('SpinPrepare', 
-                   'int', 
-                   [param('sqlite3 *', 'db'), param('sqlite3_stmt * *', 'stmt'), param('std::string const &', 'cmd')], 
-                   is_static=True, visibility='protected')
-    ## sqlite-output.h (module 'stats'): int ns3::SQLiteOutput::WaitExec(sqlite3 * db, std::string const & cmd) const [member function]
-    cls.add_method('WaitExec', 
-                   'int', 
-                   [param('sqlite3 *', 'db'), param('std::string const &', 'cmd')], 
-                   is_const=True, visibility='protected')
-    ## sqlite-output.h (module 'stats'): int ns3::SQLiteOutput::WaitExec(sqlite3 * db, sqlite3_stmt * stmt) const [member function]
-    cls.add_method('WaitExec', 
-                   'int', 
-                   [param('sqlite3 *', 'db'), param('sqlite3_stmt *', 'stmt')], 
-                   is_const=True, visibility='protected')
-    ## sqlite-output.h (module 'stats'): int ns3::SQLiteOutput::WaitPrepare(sqlite3 * db, sqlite3_stmt * * stmt, std::string const & cmd) const [member function]
-    cls.add_method('WaitPrepare', 
-                   'int', 
-                   [param('sqlite3 *', 'db'), param('sqlite3_stmt * *', 'stmt'), param('std::string const &', 'cmd')], 
-                   is_const=True, visibility='protected')
-    return
-
-def register_Ns3SqliteDataOutput_methods(root_module, cls):
-    ## sqlite-data-output.h (module 'stats'): ns3::SqliteDataOutput::SqliteDataOutput(ns3::SqliteDataOutput const & arg0) [constructor]
-    cls.add_constructor([param('ns3::SqliteDataOutput const &', 'arg0')])
-    ## sqlite-data-output.h (module 'stats'): ns3::SqliteDataOutput::SqliteDataOutput() [constructor]
-    cls.add_constructor([])
-    ## sqlite-data-output.h (module 'stats'): static ns3::TypeId ns3::SqliteDataOutput::GetTypeId() [member function]
-    cls.add_method('GetTypeId', 
-                   'ns3::TypeId', 
-                   [], 
-                   is_static=True)
-    ## sqlite-data-output.h (module 'stats'): void ns3::SqliteDataOutput::Output(ns3::DataCollector & dc) [member function]
-    cls.add_method('Output', 
-                   'void', 
-                   [param('ns3::DataCollector &', 'dc')], 
-                   is_virtual=True)
-    return
-
 def register_Ns3TimeMinMaxAvgTotalCalculator_methods(root_module, cls):
     ## time-data-calculators.h (module 'stats'): ns3::TimeMinMaxAvgTotalCalculator::TimeMinMaxAvgTotalCalculator(ns3::TimeMinMaxAvgTotalCalculator const & arg0) [constructor]
     cls.add_constructor([param('ns3::TimeMinMaxAvgTotalCalculator const &', 'arg0')])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/CMakeLists.txt ns-3.36/src/stats/CMakeLists.txt
--- ns-3.35/src/stats/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/stats/CMakeLists.txt	2022-04-30 18:23:58.150735000 -0700
@@ -0,0 +1,93 @@
+set(sqlite_sources)
+set(sqlite_header)
+set(sqlite_libraries)
+if(${ENABLE_SQLITE})
+  set(sqlite_sources
+      model/sqlite-data-output.cc
+  )
+  set(sqlite_headers
+      model/sqlite-data-output.h
+  )
+  include_directories(${SQLite3_INCLUDE_DIRS})
+  set(sqlite_libraries
+      ${SQLite3_LIBRARIES}
+  )
+  if(HAVE_SEMAPHORE_H)
+    list(
+      APPEND
+      sqlite_sources
+      model/sqlite-output.cc
+    )
+    list(
+      APPEND
+      sqlite_headers
+      model/sqlite-output.h
+    )
+  endif()
+endif()
+
+set(source_files
+    ${sqlite_sources}
+    helper/file-helper.cc
+    helper/gnuplot-helper.cc
+    model/boolean-probe.cc
+    model/data-calculator.cc
+    model/data-collection-object.cc
+    model/data-collector.cc
+    model/data-output-interface.cc
+    model/double-probe.cc
+    model/file-aggregator.cc
+    model/get-wildcard-matches.cc
+    model/gnuplot-aggregator.cc
+    model/gnuplot.cc
+    model/histogram.cc
+    model/omnet-data-output.cc
+    model/probe.cc
+    model/time-data-calculators.cc
+    model/time-probe.cc
+    model/time-series-adaptor.cc
+    model/uinteger-16-probe.cc
+    model/uinteger-32-probe.cc
+    model/uinteger-8-probe.cc
+)
+
+set(header_files
+    ${sqlite_headers}
+    helper/file-helper.h
+    helper/gnuplot-helper.h
+    model/average.h
+    model/basic-data-calculators.h
+    model/boolean-probe.h
+    model/data-calculator.h
+    model/data-collection-object.h
+    model/data-collector.h
+    model/data-output-interface.h
+    model/double-probe.h
+    model/file-aggregator.h
+    model/get-wildcard-matches.h
+    model/gnuplot-aggregator.h
+    model/gnuplot.h
+    model/histogram.h
+    model/omnet-data-output.h
+    model/probe.h
+    model/stats.h
+    model/time-data-calculators.h
+    model/time-probe.h
+    model/time-series-adaptor.h
+    model/uinteger-16-probe.h
+    model/uinteger-32-probe.h
+    model/uinteger-8-probe.h
+)
+
+build_lib(
+  LIBNAME stats
+  SOURCE_FILES ${source_files}
+  HEADER_FILES ${header_files}
+  LIBRARIES_TO_LINK ${libcore}
+                    ${sqlite_libraries}
+  TEST_SOURCES
+    test/average-test-suite.cc
+    test/basic-data-calculators-test-suite.cc
+    test/double-probe-test-suite.cc
+    test/histogram-test-suite.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/examples/CMakeLists.txt ns-3.36/src/stats/examples/CMakeLists.txt
--- ns-3.35/src/stats/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/stats/examples/CMakeLists.txt	2022-04-30 18:23:58.150735000 -0700
@@ -0,0 +1,26 @@
+build_lib_example(
+  NAME time-probe-example
+  SOURCE_FILES time-probe-example.cc
+  LIBRARIES_TO_LINK ${libstats}
+)
+
+set(base_examples
+    gnuplot-example
+    double-probe-example
+    gnuplot-aggregator-example
+    gnuplot-helper-example
+    file-aggregator-example
+    file-helper-example
+)
+
+foreach(
+  example
+  ${base_examples}
+)
+  build_lib_example(
+    NAME ${example}
+    SOURCE_FILES ${example}.cc
+    LIBRARIES_TO_LINK ${libnetwork}
+                      ${libstats}
+  )
+endforeach()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/examples/double-probe-example.cc ns-3.36/src/stats/examples/double-probe-example.cc
--- ns-3.35/src/stats/examples/double-probe-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/examples/double-probe-example.cc	2022-04-30 18:23:58.150735000 -0700
@@ -31,7 +31,7 @@
 
 NS_LOG_COMPONENT_DEFINE ("DoubleProbeExample");
 
-/*
+/**
  * This is our test object, an object that increments counters at
  * various times and emits one of them as a trace source.
  */
@@ -46,11 +46,14 @@
   Emitter ();
 private:
   void DoInitialize (void);
+
+  /// Generate data - actually this function is not traced.
   void Emit (void);
+  /// Counts how many times this function is called.
   void Count (void);
 
-  TracedValue<double> m_counter;  // normally this would be integer type
-  Ptr<ExponentialRandomVariable> m_var;
+  TracedValue<double> m_counter;  //!< Sample counter, normally this would be integer type
+  Ptr<ExponentialRandomVariable> m_var; //!< Random number generator
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/examples/file-aggregator-example.cc ns-3.36/src/stats/examples/file-aggregator-example.cc
--- ns-3.35/src/stats/examples/file-aggregator-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/examples/file-aggregator-example.cc	2022-04-30 18:23:58.150735000 -0700
@@ -25,14 +25,10 @@
 
 namespace {
 
-//===========================================================================
-// Function: CreateCommaSeparatedFile
-//
-//
-// This function creates a file with 2 columns of values and separated
-// by commas.
-//===========================================================================
-
+/**
+ * This function creates a file with 2 columns of values and separated
+ * by commas.
+ */
 void CreateCommaSeparatedFile ()
 {
   using namespace std;
@@ -69,14 +65,10 @@
 }
 
 
-//===========================================================================
-// Function: CreateSpaceSeparatedFile
-//
-//
-// This function creates a file with 2 columns of values and separated
-// by spaces.
-//===========================================================================
-
+/**
+ * This function creates a file with 2 columns of values and separated
+ * by commas.
+ */
 void CreateSpaceSeparatedFile ()
 {
   using namespace std;
@@ -114,13 +106,9 @@
 }
 
 
-//===========================================================================
-// Function: CreateFormattedFile
-//
-//
-// This function creates a file with formatted values.
-//===========================================================================
-
+/**
+ * This function creates a file with formatted values.
+ */
 void CreateFormattedFile ()
 {
   using namespace std;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/examples/file-helper-example.cc ns-3.36/src/stats/examples/file-helper-example.cc
--- ns-3.35/src/stats/examples/file-helper-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/examples/file-helper-example.cc	2022-04-30 18:23:58.150735000 -0700
@@ -34,11 +34,11 @@
 
 NS_LOG_COMPONENT_DEFINE ("FileHelperExample");
 
-//
-// This is our test object, an object that increments a counter according
-// to a Poisson process, and exports the (integer-valued) count as a
-// trace source.
-//
+/**
+ * This is our test object, an object that increments a counter according
+ * to a Poisson process, and exports the (integer-valued) count as a
+ * trace source.
+ */
 class Emitter : public Object
 {
 public:
@@ -50,10 +50,11 @@
   Emitter ();
 private:
   void DoInitialize (void);
+  /// Counts how many time this function is called.
   void Count (void);
 
-  TracedValue<uint32_t> m_counter;
-  Ptr<ExponentialRandomVariable> m_var;
+  TracedValue<uint32_t> m_counter; //!< Simple counter
+  Ptr<ExponentialRandomVariable> m_var; //!< Random number generator.
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/examples/gnuplot-aggregator-example.cc ns-3.36/src/stats/examples/gnuplot-aggregator-example.cc
--- ns-3.35/src/stats/examples/gnuplot-aggregator-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/examples/gnuplot-aggregator-example.cc	2022-04-30 18:23:58.150735000 -0700
@@ -25,13 +25,9 @@
 
 namespace {
 
-//===========================================================================
-// Function: Create2dPlot
-//
-//
-// This function creates a 2-Dimensional plot.
-//===========================================================================
-
+/**
+ * This function creates a 2-Dimensional plot.
+ */
 void Create2dPlot ()
 {
   using namespace std;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/examples/gnuplot-example.cc ns-3.36/src/stats/examples/gnuplot-example.cc
--- ns-3.35/src/stats/examples/gnuplot-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/examples/gnuplot-example.cc	2022-04-30 18:23:58.150735000 -0700
@@ -26,13 +26,9 @@
 
 namespace {
 
-//===========================================================================
-// Function: Create2DPlotFile
-//
-//
-// This function creates a 2-D plot file.
-//===========================================================================
-
+/**
+ * This function creates a 2-D plot file.
+ */
 void Create2DPlotFile ()
 {
   std::string fileNameWithNoExtension = "plot-2d";
@@ -92,13 +88,9 @@
 }
 
 
-//===========================================================================
-// Function: Create2DPlotWithErrorBarsFile
-//
-//
-// This function creates a 2-D plot with error bars file.
-//===========================================================================
-
+/**
+ * This function creates a 2-D plot with error bars file.
+ */
 void Create2DPlotWithErrorBarsFile ()
 {
   std::string fileNameWithNoExtension = "plot-2d-with-error-bars";
@@ -170,13 +162,9 @@
 }
 
 
-//===========================================================================
-// Function: Create3DPlotFile
-//
-//
-// This function creates a 3-D plot file.
-//===========================================================================
-
+/**
+ * This function creates a 3-D plot file.
+ */
 void Create3DPlotFile ()
 {
   std::string fileNameWithNoExtension = "plot-3d";
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/examples/gnuplot-helper-example.cc ns-3.36/src/stats/examples/gnuplot-helper-example.cc
--- ns-3.35/src/stats/examples/gnuplot-helper-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/examples/gnuplot-helper-example.cc	2022-04-30 18:23:58.150735000 -0700
@@ -34,11 +34,11 @@
 
 NS_LOG_COMPONENT_DEFINE ("GnuplotHelperExample");
 
-//
-// This is our test object, an object that increments a counter according
-// to a Poisson process, and exports the (integer-valued) count as a
-// trace source.
-//
+/**
+ * This is our test object, an object that increments a counter according
+ * to a Poisson process, and exports the (integer-valued) count as a
+ * trace source.
+ */
 class Emitter : public Object
 {
 public:
@@ -50,10 +50,11 @@
   Emitter ();
 private:
   void DoInitialize (void);
+  /// Counts how many time this function is called.
   void Count (void);
 
-  TracedValue<uint32_t> m_counter;
-  Ptr<ExponentialRandomVariable> m_var;
+  TracedValue<uint32_t> m_counter; //!< Simple counter
+  Ptr<ExponentialRandomVariable> m_var; //!< Random number generator.
 };
 
 NS_OBJECT_ENSURE_REGISTERED (Emitter);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/examples/time-probe-example.cc ns-3.36/src/stats/examples/time-probe-example.cc
--- ns-3.35/src/stats/examples/time-probe-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/examples/time-probe-example.cc	2022-04-30 18:23:58.150735000 -0700
@@ -45,11 +45,11 @@
 
 NS_LOG_COMPONENT_DEFINE ("TimeProbeExample");
 
-//
-// This is our test object, an object that emits values according to
-// a Poisson arrival process.   It emits a traced Time value as a 
-// trace source; this takes the value of interarrival time
-//
+/**
+ * This is our test object, an object that emits values according to
+ * a Poisson arrival process.   It emits a traced Time value as a 
+ * trace source; this takes the value of interarrival time
+ */
 class Emitter : public Object
 {
 public:
@@ -61,12 +61,12 @@
   Emitter ();
 private:
   void DoInitialize (void);
-//  void Emit (void);
+  /// Generate data.
   void Emit (void);
 
-  TracedValue<Time> m_interval;  
-  Time m_last;  
-  Ptr<ExponentialRandomVariable> m_var;
+  TracedValue<Time> m_interval;  //!< Interarrival time between events.
+  Time m_last;                   //!< Current interarrival time.
+  Ptr<ExponentialRandomVariable> m_var; //!< Random number generator.
 };
 
 NS_OBJECT_ENSURE_REGISTERED (Emitter);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/model/average.h ns-3.36/src/stats/model/average.h
--- ns-3.35/src/stats/model/average.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/model/average.h	2022-04-30 18:23:58.150735000 -0700
@@ -45,7 +45,10 @@
   {
   }
 
-  /// Add new sample
+  /**
+   * Add new sample
+   * \param x The sample
+   */
   void Update (T const & x)
   {
     // Give the variance calculator the next value.
@@ -66,19 +69,40 @@
   }
 
   // Sample statistics
-  /// Sample size
+  /**
+   * Sample size
+   * \return the sample size
+   */
   uint32_t Count   () const { return m_size; }
-  /// Minimum
+  /**
+   * Sample minimum
+   * \return the minimum of the sample
+   */
   T        Min     () const { return m_min; }
-  /// Maximum
+  /**
+   * Sample maximum
+   * \return the maximum of the sample
+   */
   T        Max     () const { return m_max; }
-  /// Sample average
+  /**
+   * Sample average
+   * \return the average of the sample
+   */
   double   Avg     () const { return m_varianceCalculator.getMean ();}
-  /// Estimate of mean, alias to Avg
+  /**
+   * Sample estimate of mean, alias to Avg
+   * \return the average of the sample
+   */
   double   Mean    () const { return Avg (); }
-  /// Unbiased estimate of variance
+  /**
+   * Sample unbiased nbiased estimate of variance
+   * \return the unbiased nbiased estimate of variance
+   */
   double   Var     () const { return m_varianceCalculator.getVariance ();}
-  /// Standard deviation
+  /**
+   * Sample standard deviation
+   * \return the standard deviation
+   */
   double   Stddev  () const { return std::sqrt (Var ()); }
 
   /**
@@ -109,7 +133,7 @@
    */
   double   Error95 () const { return 1.960 * std::sqrt (Var () / Count ()); }
   /**
-  * \brief Margin of error of the mean for 99% confidence level 
+   * \brief Margin of error of the mean for 99% confidence level 
    *
    * Note that estimates are valid for 
    *   - uncorrelated measurements, 
@@ -129,7 +153,12 @@
   MinMaxAvgTotalCalculator<double> m_varianceCalculator; //!< Variance calculator.
 };
 
-/// Print avg (err) [min, max]
+/**
+ * Print avg (err) [min, max]
+ * \param os The output stream
+ * \param x The Average value to print
+ * \return the ouput stream.
+ */
 template <typename T>
 std::ostream & operator<< (std::ostream & os, Average<T> const & x)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/model/basic-data-calculators.h ns-3.36/src/stats/model/basic-data-calculators.h
--- ns-3.35/src/stats/model/basic-data-calculators.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/model/basic-data-calculators.h	2022-04-30 18:23:58.150735000 -0700
@@ -106,6 +106,9 @@
   double getSqrSum () const { return m_squareTotal; }
 
 protected:
+  /**
+   * Dispose of this Object.
+   */
   virtual void DoDispose (void);
 
   uint32_t m_count;      //!< Count value of MinMaxAvgTotalCalculator
@@ -160,9 +163,9 @@
 TypeId
 MinMaxAvgTotalCalculator<T>::GetTypeId (void)
 {
-  static TypeId tid = TypeId ( ("ns3::MinMaxAvgTotalCalculator<"
-                                + TypeNameGet<T> ()
-                                + ">").c_str () )
+  static TypeId tid = TypeId ("ns3::MinMaxAvgTotalCalculator<"
+                              + TypeNameGet<T> ()
+                              + ">")
     .SetParent<Object> ()
     .SetGroupName ("Stats")
     .AddConstructor<MinMaxAvgTotalCalculator<T> > ()
@@ -299,6 +302,9 @@
   virtual void Output (DataOutputCallback &callback) const;
 
 protected:
+  /**
+   * Dispose of this Object.
+   */
   virtual void DoDispose (void);
 
   T m_count; //!< Count value of CounterCalculator
@@ -323,9 +329,9 @@
 TypeId
 CounterCalculator<T>::GetTypeId (void)
 {
-  static TypeId tid = TypeId ( ("ns3::CounterCalculator<"
-                                + TypeNameGet<T> ()
-                                + ">").c_str () )
+  static TypeId tid = TypeId ("ns3::CounterCalculator<"
+                              + TypeNameGet<T> ()
+                              + ">")
     .SetParent<Object> ()
     .SetGroupName ("Stats")
     .AddConstructor<CounterCalculator<T> > ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/model/data-collection-object.h ns-3.36/src/stats/model/data-collection-object.h
--- ns-3.35/src/stats/model/data-collection-object.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/model/data-collection-object.h	2022-04-30 18:23:58.150735000 -0700
@@ -51,13 +51,22 @@
   /// Unset the status of an individual object.
   void Disable (void);
 
-  /// Check the status of an individual object.
+  /**
+   * Check the status of an individual object.
+   * \return true if the object is enabled
+   */
   virtual bool IsEnabled (void) const;
 
-  /// Get the object's name.
+  /**
+   * Get the object's name.
+   * \return the object's name
+   */
   std::string GetName (void) const;
 
-  /// Set the object's name.  All spaces are replaced by underscores.
+  /**
+   * Set the object's name.
+   * \param name the object's name
+   */
   void SetName (std::string name);
 
 protected:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/model/gnuplot.cc ns-3.36/src/stats/model/gnuplot.cc
--- ns-3.35/src/stats/model/gnuplot.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/model/gnuplot.cc	2022-04-30 18:23:58.154734800 -0700
@@ -325,7 +325,9 @@
 
 // --- Gnuplot2dDataset ---------------------------------------------------- //
 
+/// Default plot style static instance
 enum Gnuplot2dDataset::Style Gnuplot2dDataset::m_defaultStyle = LINES;
+/// Default error bars type static instance
 enum Gnuplot2dDataset::ErrorBars Gnuplot2dDataset::m_defaultErrorBars = NONE;
 
 Gnuplot2dDataset::Gnuplot2dDataset (const std::string& title)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/model/gnuplot.h ns-3.36/src/stats/model/gnuplot.h
--- ns-3.35/src/stats/model/gnuplot.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/model/gnuplot.h	2022-04-30 18:23:58.154734800 -0700
@@ -142,7 +142,7 @@
   };
 
   /**
-   * \param title the title to be associated to this dataset.
+   * \param title the title to be associated to this dataset (default "Untitled").
    *
    * Create an empty dataset. Usually, the dataset's title is 
    * displayed in the legend box.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/model/sqlite-data-output.h ns-3.36/src/stats/model/sqlite-data-output.h
--- ns-3.35/src/stats/model/sqlite-data-output.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/model/sqlite-data-output.h	2022-04-30 18:23:58.154734800 -0700
@@ -63,7 +63,7 @@
 public:
     /**
      * Constructor
-     * \param owner pointer to the instance this object belongs to
+     * \param db pointer to the instance this object belongs to
      * \param run experiment descriptor
      */
     SqliteOutputCallback (const Ptr<SQLiteOutput> &db, std::string run);
@@ -137,7 +137,7 @@
     Ptr<SQLiteOutput> m_db; //!< Db
     std::string m_runLabel; //!< Run label
 
-
+    /// Pointer to a Sqlite3 singleton statement
     sqlite3_stmt *m_insertSingletonStatement;
   };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/model/sqlite-output.cc ns-3.36/src/stats/model/sqlite-output.cc
--- ns-3.35/src/stats/model/sqlite-output.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/model/sqlite-output.cc	2022-04-30 18:23:58.154734800 -0700
@@ -20,7 +20,6 @@
 #include <sys/stat.h>
 #include <fcntl.h>
 #include "ns3/abort.h"
-#include "ns3/unused.h"
 #include "ns3/log.h"
 #include "ns3/nstime.h"
 
@@ -90,13 +89,12 @@
 
 template<typename T>
 T
-SQLiteOutput::RetrieveColumn (sqlite3_stmt *stmt, int pos) const
+SQLiteOutput::RetrieveColumn ([[maybe_unused]] sqlite3_stmt *stmt, [[maybe_unused]] int pos) const
 {
-  NS_UNUSED (stmt);
-  NS_UNUSED (pos);
   NS_FATAL_ERROR ("Can't call generic fn");
 }
 
+/// \copydoc SQLiteOutput::RetrieveColumn
 template<>
 int
 SQLiteOutput::RetrieveColumn (sqlite3_stmt *stmt, int pos) const
@@ -104,6 +102,7 @@
   return sqlite3_column_int (stmt, pos);
 }
 
+/// \copydoc SQLiteOutput::RetrieveColumn
 template<>
 uint32_t
 SQLiteOutput::RetrieveColumn (sqlite3_stmt *stmt, int pos) const
@@ -111,6 +110,7 @@
   return static_cast<uint32_t> (sqlite3_column_int (stmt, pos));
 }
 
+/// \copydoc SQLiteOutput::RetrieveColumn
 template<>
 double
 SQLiteOutput::RetrieveColumn (sqlite3_stmt *stmt, int pos) const
@@ -120,15 +120,13 @@
 
 template<typename T>
 bool
-SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const T &value) const
+SQLiteOutput::Bind ([[maybe_unused]] sqlite3_stmt *stmt, [[maybe_unused]] int pos, [[maybe_unused]] const T &value) const
 {
-  NS_UNUSED (stmt);
-  NS_UNUSED (pos);
-  NS_UNUSED (value);
   NS_FATAL_ERROR ("Can't call generic fn");
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const Time &value) const
@@ -140,6 +138,7 @@
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const double &value) const
@@ -151,6 +150,7 @@
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const uint32_t &value) const
@@ -162,6 +162,7 @@
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const long &value) const
@@ -173,6 +174,7 @@
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const long long &value) const
@@ -184,6 +186,7 @@
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const uint16_t &value) const
@@ -195,6 +198,7 @@
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const uint8_t &value) const
@@ -206,6 +210,7 @@
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const int &value) const
@@ -217,6 +222,7 @@
   return false;
 }
 
+//! \copydoc SQLiteOutput::Bind
 template<>
 bool
 SQLiteOutput::Bind (sqlite3_stmt *stmt, int pos, const std::string &value) const
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/stats/model/sqlite-output.h ns-3.36/src/stats/model/sqlite-output.h
--- ns-3.35/src/stats/model/sqlite-output.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/stats/model/sqlite-output.h	2022-04-30 18:23:58.154734800 -0700
@@ -113,6 +113,7 @@
    * \param stmt Sqlite statement
    * \param pos Position of the bind argument inside the statement
    * \param value Value to bind
+   * \return true on success, false otherwise
    */
   template<typename T>
   bool Bind (sqlite3_stmt *stmt, int pos, const T &value) const;
@@ -121,6 +122,7 @@
    * \brief Retrieve a value from an executed statement
    * \param stmt sqlite statement
    * \param pos Column position
+   * \return the value from the executed statement
    */
   template<typename T>
   T RetrieveColumn (sqlite3_stmt *stmt, int pos) const;
@@ -185,7 +187,14 @@
    */
   static int SpinExec (sqlite3 *db, const std::string &cmd);
 
+  /**
+   * \brief Execute a Prepared Statement Object ignoring concurrency problems, retrying instead
+   * \param db Database
+   * \param stmt Prepared Statement Object
+   * \return Sqlite error code
+   */
   static int SpinExec (sqlite3 *db, sqlite3_stmt *stmt);
+  
   /**
    * \brief Preparing a command ignoring concurrency problems, retrying instead
    * \param db Database
